CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to build a login page in React

Building a secure and user-friendly login page is the foundation of most web applications, requiring careful attention to form validation, error handling, and API integration. As the creator of CoreUI, I’ve built authentication systems for countless enterprise applications and admin dashboards. From my expertise, the most effective approach is to create a controlled form component with proper validation, loading states, and error feedback that integrates seamlessly with your backend API. This method provides immediate user feedback, prevents invalid submissions, and handles authentication errors gracefully.

Build a controlled form component with email and password inputs, validation, and API integration.

import { useState } from 'react'

const LoginPage = () => {
  const [formData, setFormData] = useState({
    email: '',
    password: ''
  })
  const [errors, setErrors] = useState({})
  const [loading, setLoading] = useState(false)

  const handleChange = (e) => {
    const { name, value } = e.target
    setFormData(prev => ({
      ...prev,
      [name]: value
    }))
    if (errors[name]) {
      setErrors(prev => ({ ...prev, [name]: '' }))
    }
  }

  const handleSubmit = async (e) => {
    e.preventDefault()

    const newErrors = validateForm(formData)
    if (Object.keys(newErrors).length > 0) {
      setErrors(newErrors)
      return
    }

    setLoading(true)
    try {
      const response = await fetch('/api/auth/login', {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify(formData)
      })

      if (!response.ok) {
        throw new Error('Login failed')
      }

      const data = await response.json()
      localStorage.setItem('token', data.token)
      window.location.href = '/dashboard'
    } catch (error) {
      setErrors({ submit: 'Invalid email or password' })
    } finally {
      setLoading(false)
    }
  }

  return (
    <div className="login-container">
      <form onSubmit={handleSubmit} className="login-form">
        <h1>Login</h1>

        <div className="form-group">
          <label htmlFor="email">Email</label>
          <input
            type="email"
            id="email"
            name="email"
            value={formData.email}
            onChange={handleChange}
            disabled={loading}
          />
          {errors.email && <span className="error">{errors.email}</span>}
        </div>

        <div className="form-group">
          <label htmlFor="password">Password</label>
          <input
            type="password"
            id="password"
            name="password"
            value={formData.password}
            onChange={handleChange}
            disabled={loading}
          />
          {errors.password && <span className="error">{errors.password}</span>}
        </div>

        {errors.submit && <div className="error-message">{errors.submit}</div>}

        <button type="submit" disabled={loading}>
          {loading ? 'Logging in...' : 'Login'}
        </button>
      </form>
    </div>
  )
}

const validateForm = (data) => {
  const errors = {}

  if (!data.email) {
    errors.email = 'Email is required'
  } else if (!/\S+@\S+\.\S+/.test(data.email)) {
    errors.email = 'Email is invalid'
  }

  if (!data.password) {
    errors.password = 'Password is required'
  } else if (data.password.length < 6) {
    errors.password = 'Password must be at least 6 characters'
  }

  return errors
}

export default LoginPage

How It Works

This login page uses controlled components where form inputs are bound to React state through the value prop and updated via onChange handlers. The handleSubmit function prevents the default form submission, validates the input data, and makes an API call to authenticate the user. On successful login, the authentication token is stored in localStorage and the user is redirected to the dashboard. Error states provide feedback for validation failures and API errors.

Adding Loading State

Enhance the user experience with loading indicators:

const LoginPage = () => {
  const [loading, setLoading] = useState(false)

  const handleSubmit = async (e) => {
    e.preventDefault()
    setLoading(true)

    try {
      const response = await fetch('/api/auth/login', {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify(formData)
      })

      const data = await response.json()

      if (!response.ok) {
        throw new Error(data.message || 'Login failed')
      }

      localStorage.setItem('token', data.token)
      window.location.href = '/dashboard'
    } catch (error) {
      setErrors({ submit: error.message })
    } finally {
      setLoading(false)
    }
  }

  return (
    <button type="submit" disabled={loading}>
      {loading ? (
        <>
          <span className="spinner" />
          Logging in...
        </>
      ) : (
        'Login'
      )}
    </button>
  )
}

The loading state disables form inputs and the submit button during API calls, preventing duplicate submissions. The button text changes to indicate the login is in progress.

Real-time Validation

Add real-time validation as users type:

const LoginPage = () => {
  const [touched, setTouched] = useState({})

  const handleBlur = (e) => {
    const { name } = e.target
    setTouched(prev => ({ ...prev, [name]: true }))

    const fieldErrors = validateField(name, formData[name])
    if (fieldErrors) {
      setErrors(prev => ({ ...prev, [name]: fieldErrors }))
    } else {
      setErrors(prev => {
        const newErrors = { ...prev }
        delete newErrors[name]
        return newErrors
      })
    }
  }

  const validateField = (name, value) => {
    switch (name) {
      case 'email':
        if (!value) return 'Email is required'
        if (!/\S+@\S+\.\S+/.test(value)) return 'Email is invalid'
        return null
      case 'password':
        if (!value) return 'Password is required'
        if (value.length < 6) return 'Password must be at least 6 characters'
        return null
      default:
        return null
    }
  }

  return (
    <input
      type="email"
      name="email"
      value={formData.email}
      onChange={handleChange}
      onBlur={handleBlur}
    />
  )
}

The onBlur handler validates each field when the user leaves it, providing immediate feedback. The touched state tracks which fields have been interacted with to avoid showing errors prematurely.

Remember Me Functionality

Add a “remember me” checkbox to persist user sessions:

const LoginPage = () => {
  const [rememberMe, setRememberMe] = useState(false)

  const handleSubmit = async (e) => {
    e.preventDefault()

    try {
      const response = await fetch('/api/auth/login', {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify(formData)
      })

      const data = await response.json()

      const storage = rememberMe ? localStorage : sessionStorage
      storage.setItem('token', data.token)

      window.location.href = '/dashboard'
    } catch (error) {
      setErrors({ submit: 'Invalid email or password' })
    }
  }

  return (
    <div className="form-check">
      <input
        type="checkbox"
        id="rememberMe"
        checked={rememberMe}
        onChange={(e) => setRememberMe(e.target.checked)}
      />
      <label htmlFor="rememberMe">Remember me</label>
    </div>
  )
}

When “remember me” is checked, the token is stored in localStorage for persistence across browser sessions. Otherwise, it’s stored in sessionStorage and cleared when the browser closes.

Password Visibility Toggle

Allow users to toggle password visibility:

const LoginPage = () => {
  const [showPassword, setShowPassword] = useState(false)

  return (
    <div className="form-group password-field">
      <label htmlFor="password">Password</label>
      <div className="input-wrapper">
        <input
          type={showPassword ? 'text' : 'password'}
          id="password"
          name="password"
          value={formData.password}
          onChange={handleChange}
        />
        <button
          type="button"
          className="toggle-password"
          onClick={() => setShowPassword(!showPassword)}
          aria-label={showPassword ? 'Hide password' : 'Show password'}
        >
          {showPassword ? '👁️' : '👁️‍🗨️'}
        </button>
      </div>
    </div>
  )
}

The toggle button switches the input type between ‘password’ and ’text’, allowing users to verify they’ve typed their password correctly.

Add a forgot password link with navigation:

import { Link } from 'react-router-dom'

const LoginPage = () => {
  return (
    <form onSubmit={handleSubmit}>
      <div className="form-footer">
        <Link to="/forgot-password">Forgot password?</Link>
      </div>

      <button type="submit">Login</button>

      <div className="signup-link">
        Don't have an account? <Link to="/signup">Sign up</Link>
      </div>
    </form>
  )
}

These links provide navigation to password recovery and account creation pages, improving the overall authentication flow.

Best Practice Note

At CoreUI, our React admin templates include production-ready login pages with advanced features like OAuth integration, two-factor authentication, and role-based redirects. When building authentication flows, always validate on both the client and server side - never trust client-side validation alone. For complete authentication systems, consider integrating your login page with a dashboard in React and complementing it with a signup page in React. Store authentication tokens securely, use HTTPS in production, and implement proper CSRF protection. Remember to handle edge cases like expired sessions, account lockouts after failed attempts, and email verification requirements for a robust authentication experience.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
Do we need UI components?
Do we need UI components?

Can’t wait for what the future of Vue holds!
Can’t wait for what the future of Vue holds!

CoreUI Vue.js components helped to win a Eurostat hackathon
CoreUI Vue.js components helped to win a Eurostat hackathon

UI Components For Bootstrap — Part 1 by Mehwash Patel
UI Components For Bootstrap — Part 1 by Mehwash Patel

CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to build a login page in Angular

A login page in Angular requires a reactive form with validation, an auth service that calls your backend and stores the JWT, and a route guard that redirects unauthenticated users. As the creator of CoreUI with Angular development experience since 2014, I’ve built the authentication flows in CoreUI Angular templates used by thousands of enterprise developers. The key is separating form logic, HTTP calls, and token storage into distinct layers so each piece is independently testable. A login page that looks professional and handles errors gracefully significantly impacts first impressions of your application.

Build the login form using Angular Reactive Forms and CoreUI components.

// login.component.ts
import { Component } from '@angular/core'
import { CommonModule } from '@angular/common'
import { ReactiveFormsModule, FormBuilder, Validators } from '@angular/forms'
import { Router } from '@angular/router'
import {
  CardModule,
  FormModule,
  ButtonModule,
  GridModule,
  AlertComponent
} from '@coreui/angular'
import { AuthService } from '../auth/auth.service'

@Component({
  selector: 'app-login',
  standalone: true,
  imports: [CommonModule, ReactiveFormsModule, CardModule, FormModule, ButtonModule, GridModule, AlertComponent],
  template: `
    <div class="min-vh-100 d-flex align-items-center">
      <c-container>
        <c-row class="justify-content-center">
          <c-col md="6" lg="5">
            <c-card class="p-4">
              <c-card-body>
                <h1 class="h4 mb-4">Login</h1>

                <c-alert color="danger" *ngIf="error">{{ error }}</c-alert>

                <form [formGroup]="form" (ngSubmit)="submit()">
                  <div class="mb-3">
                    <label cLabel for="email">Email</label>
                    <input
                      cFormControl
                      id="email"
                      type="email"
                      formControlName="email"
                      placeholder="[email protected]"
                      [class.is-invalid]="isInvalid('email')"
                    />
                    <c-form-feedback *ngIf="isInvalid('email')">
                      Valid email is required
                    </c-form-feedback>
                  </div>

                  <div class="mb-4">
                    <label cLabel for="password">Password</label>
                    <input
                      cFormControl
                      id="password"
                      type="password"
                      formControlName="password"
                      [class.is-invalid]="isInvalid('password')"
                    />
                    <c-form-feedback *ngIf="isInvalid('password')">
                      Password must be at least 6 characters
                    </c-form-feedback>
                  </div>

                  <button
                    cButton
                    color="primary"
                    type="submit"
                    class="w-100"
                    [disabled]="loading"
                  >
                    {{ loading ? 'Signing in...' : 'Sign In' }}
                  </button>
                </form>
              </c-card-body>
            </c-card>
          </c-col>
        </c-row>
      </c-container>
    </div>
  `
})
export class LoginComponent {
  loading = false
  error = ''

  form = this.fb.group({
    email: ['', [Validators.required, Validators.email]],
    password: ['', [Validators.required, Validators.minLength(6)]]
  })

  constructor(
    private fb: FormBuilder,
    private auth: AuthService,
    private router: Router
  ) {}

  isInvalid(field: string): boolean {
    const control = this.form.get(field)
    return !!(control?.invalid && control.touched)
  }

  async submit(): Promise<void> {
    if (this.form.invalid) {
      this.form.markAllAsTouched()
      return
    }

    this.loading = true
    this.error = ''

    try {
      await this.auth.login(
        this.form.value.email!,
        this.form.value.password!
      )
      this.router.navigate(['/dashboard'])
    } catch (err: any) {
      this.error = err.message ?? 'Login failed. Please try again.'
    } finally {
      this.loading = false
    }
  }
}

markAllAsTouched() triggers validation display on all fields when the user submits with empty fields. The isInvalid helper checks if a field has errors AND has been touched — this prevents showing errors before the user has interacted with the field.

Auth Service

Handle JWT storage and HTTP login.

// auth/auth.service.ts
import { Injectable } from '@angular/core'
import { HttpClient } from '@angular/common/http'
import { firstValueFrom } from 'rxjs'

@Injectable({ providedIn: 'root' })
export class AuthService {
  constructor(private http: HttpClient) {}

  async login(email: string, password: string): Promise<void> {
    const { token } = await firstValueFrom(
      this.http.post<{ token: string }>('/api/auth/login', { email, password })
    )
    localStorage.setItem('token', token)
  }

  logout(): void {
    localStorage.removeItem('token')
  }

  getToken(): string | null {
    return localStorage.getItem('token')
  }

  isLoggedIn(): boolean {
    return !!this.getToken()
  }
}

Route Guard

Redirect unauthenticated users to the login page.

// guards/auth.guard.ts
import { inject } from '@angular/core'
import { Router } from '@angular/router'
import { AuthService } from '../auth/auth.service'

export const authGuard = () => {
  const auth = inject(AuthService)
  const router = inject(Router)
  return auth.isLoggedIn() ? true : router.parseUrl('/login')
}

Best Practice Note

This is the exact login page structure used in CoreUI Angular Admin Template, which includes a polished login page with a full authentication flow ready to connect to your backend. For production, add token refresh logic, handle token expiry, and consider using sessionStorage instead of localStorage for stricter security. See how to build a signup page in Angular for the companion registration flow.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.